Batch create NPCs
curl --request POST \
--url https://api.kitefrost.ai/v1/projects/{project_id}/game-narrative/characters/batch \
--header 'Content-Type: application/json' \
--data '
{
"npcs": [
{
"npc_name": "Aria Shadowstep",
"npc_role": "merchant",
"personality_hints": [
"cunning",
"secretive",
"charming"
],
"player_actions": [
"talk",
"trade",
"persuade"
],
"project_context": "A bustling port city in a high-fantasy setting"
}
]
}
'import requests
url = "https://api.kitefrost.ai/v1/projects/{project_id}/game-narrative/characters/batch"
payload = { "npcs": [
{
"npc_name": "Aria Shadowstep",
"npc_role": "merchant",
"personality_hints": ["cunning", "secretive", "charming"],
"player_actions": ["talk", "trade", "persuade"],
"project_context": "A bustling port city in a high-fantasy setting"
}
] }
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
npcs: [
{
npc_name: 'Aria Shadowstep',
npc_role: 'merchant',
personality_hints: ['cunning', 'secretive', 'charming'],
player_actions: ['talk', 'trade', 'persuade'],
project_context: 'A bustling port city in a high-fantasy setting'
}
]
})
};
fetch('https://api.kitefrost.ai/v1/projects/{project_id}/game-narrative/characters/batch', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
[
{
"created_at": "2026-01-01T12:00:00Z",
"name": "Aria Shadowstep",
"npc_id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
"project_id": "proj_abc123",
"session_id": "sess_xyz789",
"status": "brainstorm"
}
]{
"error": "Not found",
"code": "not_found",
"request_id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"message": "The requested resource does not exist.",
"doc_url": "https://docs.kitefrost.ai/errors/not_found"
}{
"error": "Internal server error",
"code": "internal_error",
"request_id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"message": "An unexpected error occurred.",
"doc_url": "https://docs.kitefrost.ai/errors/internal_error"
}characters
Batch create NPCs
Create multiple NPCs in one call (max 50).
POST
/
v1
/
projects
/
{project_id}
/
game-narrative
/
characters
/
batch
Batch create NPCs
Body
application/json
POST /v1/projects/{project_id}/characters/batch
List of NPC definitions to create (max 50)
Required array length:
1 - 50 elementsShow child attributes
Show child attributes
Response
NPCs created successfully
Unique NPC identifier (UUID)
Display name of the NPC
Project this NPC belongs to
Lifecycle status: brainstorm | draft | final
Active generation session ID, if any
ISO 8601 creation timestamp
URL of the generated character portrait when generate_portrait=true was passed and image generation succeeded. Null otherwise.
⌘I